CMInterfacePanel = { } ;
function CMInterfacePanel:new(o)
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end
function CMInterfacePanel:init(cm, config)
	self.cm = cm
	self.cmConfig = config

	self.colPadding = 20
	self.rowSize = 25

	self.panel = CreateFrame("Frame", "ChartMeInterfacePanel", UIParent)
	self.panel.name = "ChartMe!"
	self.configInterface = {}
	local row = 1


	local headingFrame = CreateFrame("Frame", "HeadingFrame", self.panel)
	headingFrame:ClearAllPoints()
	headingFrame:SetPoint("TOPLEFT", self.colPadding, self.rowSize*row)
	headingFrame.text = self.panel:CreateFontString("HeadingText", "ARTWORK", "PVPInfoTextFont")
	headingFrame.text:SetAllPoints();
	headingFrame.text:SetPoint("TOPLEFT", 0, -10)
	headingFrame.text:SetText("ChartMe! Settings")
	headingFrame.text:SetJustifyH("CENTER")
	headingFrame.text:SetJustifyV("TOP")
	row = row + 1

	for measure, measureConfig in pairs(self.cmConfig.measure) do
		--print(measure .. " " .. measureConfig.title)
		local f = CreateFrame("CheckButton", "displayMeasures"..measure, self.panel, "UICheckButtonTemplate")
		f.measure = measure
		f:ClearAllPoints()
		f:SetPoint("TOPLEFT", 25, row*-25)
		_G[f:GetName() .. "Text"]:SetText(measureConfig.title)
		if CMUtils.inTable(measure, self.cmConfig.displayMeasures) then
			f:SetChecked(true)
		end
		self.configInterface["displayMeasure"..measure] = f
		row = row + 1

	end

	--Use own HP as max in Graphs
	local f2 = CreateFrame("CheckButton", "maxDmgOwnHp", self.panel, "UICheckButtonTemplate")
	f2:ClearAllPoints()
	f2:SetPoint("TOPLEFT", 25, row*-25)
	row = row + 1
	InterfaceOptions_AddCategory(self.panel)
	_G[f2:GetName() .. "Text"]:SetText("Start with own HP as scale in graphs")
	f2:SetChecked(self.cmConfig.setMaxGraphToMaxHp)
	self.configInterface["maxDmgOwnHp"] = f2

	--All visible graphs share maxDmg
	local f3 = CreateFrame("CheckButton", "maxDmgAllVisible", self.panel, "UICheckButtonTemplate")
	f3:ClearAllPoints()
	f3:SetPoint("TOPLEFT", 25, row*-25)
	row = row + 1
	InterfaceOptions_AddCategory(self.panel)
	_G[f3:GetName() .. "Text"]:SetText("All visible graphs share scale")
	f3:SetChecked(self.cmConfig.setMaxGraphToAllVisible)
	self.configInterface["maxDmgAllVisible"] = f3
	local me = self
	self.panel.okay = function (self) me:save() end 
end

function CMInterfacePanel:save()
	local dm = {}
	
	for l, f in pairs(self.configInterface) do
		if (string.sub(l,1,14) == "displayMeasure") then
			--print ("is displayMeasure")
			if f:GetChecked() then
				table.insert(dm, f.measure);
			end
		end
	end
	self.cmConfig.displayMeasures = dm

	if (self.configInterface["maxDmgOwnHp"]) then
		--print (CMUtils.dump(self.configInterface["maxDmgOwnHp"]))
		local f2 = self.configInterface["maxDmgOwnHp"]
		self.cmConfig.setMaxGraphToMaxHp = f2:GetChecked()
	end
	if (self.configInterface["maxDmgAllVisible"]) then
		--print ("setting setMaxGraphToAllVisible to true/false")
		--print (CMUtils.dump(self.configInterface["maxDmgAllVisible"]))
		local f3 = self.configInterface["maxDmgAllVisible"]
		self.cmConfig.setMaxGraphToAllVisible = f3:GetChecked()
	end
	self.cm:redrawGraphFrames()
end

function CMInterfacePanel:forceOpen()
	InterfaceOptionsFrame_OpenToCategory(self.panel)
end
